﻿using System;
using System.Threading;

namespace ConsoleApplication1
{
    class Program
    {
        delegate int? MyDivide(int a, int b);

        static void Main(string[] args)
        {
            Thread thread = new Thread(ThreadFunc);
            thread.Start();

            thread.Join();

            thread = new Thread(
                delegate(object obj)
                {
                    Console.WriteLine("ThreadFunc in anonymous method called!");
                });
            thread.Start();
            thread.Join();

            thread = new Thread(
                delegate()
                {
                    Console.WriteLine("ThreadFunc in anonymous method called!");
                });
            thread.Start();
            thread.Join();

            MyDivide myFunc = delegate(int a, int b)
            {
                if (b == 0)
                {
                    return null;
                }

                return a / b;
            };

            Console.WriteLine("10 / 2 == " + myFunc(10, 2));
            Console.WriteLine("10 / 0 == " + myFunc(10, 0));
        }

        private static void ThreadFunc(object obj)
        {
            Console.WriteLine("ThreadFunc called!");
        }
    }
}
